//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 2/25/2005 2:18:01 PM                 //
//                                                     //
//-----------------------------------------------------//


// Structures
struct Technique1_Pass1_VS_OUT 
{
	float4 position : POSITION;
	float2 uv0 : TEXCOORD0;
	float2 uv1 : TEXCOORD1;
	float uv2 : TEXCOORD2;
};

struct Technique1_Pass1_PS_OUT 
{
	float4 color : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
float time : Time = 0.0;
texture Texture_1
<
	string name = "concrete.jpg";
	string UIName = "Texture 1";

>;
texture Texture_2
<
	string name = "rtzen.tga";
	string UIName = "Texture 2";

>;
texture noiseTable : NoiseTable2D;

// Samplers
sampler2D Texture_1Sampler = sampler_state
{
	Texture = <Texture_1>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

sampler2D Texture_2Sampler = sampler_state
{
	Texture = <Texture_2>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

sampler2D noiseTableSampler = sampler_state
{
	Texture = <noiseTable>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
};


// Functions
float PixelNoise(
		float2 v,
		sampler2D nt)
{
	float2 I;
	float2 F = modf(abs(v), I);
	float2 u = ((F*F)*F)*((F*((F*6)-15))+10);
	float2 I0 = I/64;
	float2 I1 = I0+0.015625;
	float2 v0;
	float2 v1;
	float2 v2;
	float2 v3;
	float2 g0;
	float2 g1;
	float2 g2;
	float2 g3;
	g0 = ((tex2D(nt, float2(I0.x, I0.y))*2)-1);
	g1 = ((tex2D(nt, float2(I1.x, I0.y))*2)-1);
	g2 = ((tex2D(nt, float2(I0.x, I1.y))*2)-1);
	g3 = ((tex2D(nt, float2(I1.x, I1.y))*2)-1);
	v0 = dot(g0, float2(F.x, F.y));
	v1 = dot(g1, float2(F.x-1, F.y));
	v2 = dot(g2, float2(F.x, F.y-1));
	v3 = dot(g3, float2(F.x-1, F.y-1));
	return lerp(lerp(v0, v1, u.x), lerp(v2, v3, u.x), u.y);
}

float VertexNoise(
		float2 v)
{
	int permTable[64] = { 18, 25, 21, 14, 16, 0, 27, 4, 31, 9, 13, 11, 26, 23, 5, 17, 30, 1, 19, 3, 6, 24, 8, 28, 2, 29, 15, 10, 20, 12, 7, 22, 18, 25, 21, 14, 16, 0, 27, 4, 31, 9, 13, 11, 26, 23, 5, 17, 30, 1, 19, 3, 6, 24, 8, 28, 2, 29, 15, 10, 20, 12, 7, 22 };
	float3 gradTable[12] = { float3(1, 1, 0), float3(-1, 1, 0), float3(1, -1, 0), float3(-1, -1, 0), float3(1, 0, 1), float3(-1, 0, 1), float3(1, 0, -1), float3(-1, 0, -1), float3(0, 1, 1), float3(0, -1, 1), float3(0, 1, -1), float3(0, -1, -1) };
	float2 I;
	float2 F = modf(abs(v), I);
	I = (I%32);
	float uu = ((F.x*F.x)*F.x)*((F.x*((F.x*6)-15))+10);
	float vv = ((F.y*F.y)*F.y)*((F.y*((F.y*6)-15))+10);
	int A = permTable[I.x]+I.y;
	int B = permTable[I.x+1]+I.y;
	float dA0 = dot(gradTable[permTable[A]%12], float3(F.x, F.y, 0));
	float dA1 = dot(gradTable[permTable[B]%12], float3(F.x-1, F.y, 0));
	float dB0 = dot(gradTable[permTable[A+1]%12], float3(F.x, F.y-1, 0));
	float dB1 = dot(gradTable[permTable[B+1]%12], float3(F.x-1, F.y-1, 0));
	return lerp(lerp(dA0, dA1, uu), lerp(dB0, dB1, uu), vv);
}

Technique1_Pass1_VS_OUT Technique1_Pass1_VS(
		float3 pos : POSITION,
		float2 uv0 : TEXCOORD0,
		uniform float4x4 projTM,
		uniform float time)
{
	Technique1_Pass1_VS_OUT OUT;
	OUT.position = mul(float4(pos.xyz, 1), projTM);
	OUT.uv0 = uv0;
	float a1 = uv0.x;
	float xValue1 = a1*5;
	float a2 = uv0.y;
	float yValue1 = a2*5;
	float2 vect1 = float2(xValue1, yValue1);
	float a3 = vect1.y;
	float xValue2 = a3/0.3;
	float yValue2 = time/2;
	float2 v1 = float2(xValue2, yValue2);
	float xValue3 = VertexNoise(v1);
	float a4 = vect1.x;
	float xValue4 = a4/0.3;
	float2 v2 = float2(xValue4, yValue2);
	float yValue3 = VertexNoise(v2);
	float2 a5 = float2(xValue3, yValue3);
	float2 a6 = a5*0.5;
	OUT.uv1 = a6+vect1;
	float u1 = time/1;
	float a7 = sin(u1);
	float a8 = a7+1.0;
	float a9 = a8*0.5;
	OUT.uv2 = a9*1;
	return OUT;
}

Technique1_Pass1_PS_OUT Technique1_Pass1_PS(
		float2 uv0 : TEXCOORD0,
		float2 uv1 : TEXCOORD1,
		float uv2 : TEXCOORD2,
		uniform sampler2D Texture_1Sampler,
		uniform sampler2D Texture_2Sampler,
		uniform sampler2D noiseTableSampler)
{
	Technique1_Pass1_PS_OUT OUT;
	float4 color01 = tex2D(Texture_1Sampler, uv0.xy);
	float4 color11 = tex2D(Texture_2Sampler, uv0.xy);
	float a1 = PixelNoise(uv1, noiseTableSampler);
	float a2 = a1+0.5;
	float b1 = uv2*0.8;
	float u1 = clamp(a2, b1, 1);
	OUT.color = lerp(color01, color11, u1);
	return OUT;
}


// Techniques
technique Technique1
{
	pass Pass1
	{
		VertexShader = compile vs_3_0 Technique1_Pass1_VS(projTM, time);
		PixelShader = compile ps_3_0 Technique1_Pass1_PS(Texture_1Sampler, Texture_2Sampler, noiseTableSampler);
		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		AlphaBlendEnable = false;
	}
}

