//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 2/25/2005 12:19:56 PM                //
//                                                     //
//-----------------------------------------------------//


// Structures
struct LightParameters 
{
	float4 position;
	float4 color;
};

struct Technique1_Pass1_VS_OUT 
{
	float4 position : POSITION;
	float2 uv0 : TEXCOORD0;
	float2 uv1 : TEXCOORD1;
	float3 eyeVect2 : TEXCOORD2;
	float4 light0Vect : COLOR0;
	float4 light1Vect : COLOR1;
	float3 eyeVect : TEXCOORD3;
};

struct Technique1_Pass1_PS_OUT 
{
	float4 color : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
float4x4 worldITM : WorldI;
float4 eyePos : WorldEyePosition;
LightParameters lightArray[4] : WorldLightParameters;
texture Texture2
<
	string name = "C:\\project\\RTzen\\source\\src\\bin\\media\\images\\tile05_color.bmp";
	string UIName = "Texture2";

>;
texture Texture
<
	string name = "C:\\project\\RTzen\\source\\src\\bin\\media\\images\\tile05_height.bmp";
	string UIName = "Texture";

>;
texture Texture3
<
	string name = "C:\\project\\RTzen\\source\\src\\bin\\media\\images\\tile05_normal.bmp";
	string UIName = "Texture3";

>;

// Samplers
sampler2D Texture2Sampler = sampler_state
{
	Texture = <Texture2>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

sampler2D TextureSampler = sampler_state
{
	Texture = <Texture>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

sampler2D Texture3Sampler = sampler_state
{
	Texture = <Texture3>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


// Functions
float4 TangentSpaceTransform(
		float4x4 worldITM,
		float3 surfPos,
		float4 lightPos,
		float3 tangent,
		float3 binormal,
		float3 normal)
{
	float4 lightPosLocal = mul(lightPos, worldITM);
	float3 lightVect = normalize(lightPosLocal.xyz-surfPos.xyz);
	float3x3 tangentSpaceTM;
	tangentSpaceTM[0] = tangent;
	tangentSpaceTM[1] = binormal;
	tangentSpaceTM[2] = normal;
	return float4(mul(tangentSpaceTM, lightVect), 1);
}

float2 Parallax(
		float2 uv,
		float3 eye,
		float height,
		float disp)
{
	float3 eyeVect = normalize(eye.xyz);
	float offset = (height*disp)-(disp/2);
	return uv+float2(eyeVect.x*offset, eyeVect.y*(-offset));
}

float2x3 PerPixelLighting(
		float4 normal,
		float4 eyeVec,
		float4 light0,
		float4 light1,
		float4 color0,
		float4 color1)
{
	float2x3 illum = float2x3(0, 0, 0, 0, 0, 0);
	float3 lt0 = (light0.xyz-0.5)*2;
	float3 lt1 = (light1.xyz-0.5)*2;
	float3 halfVec0 = normalize(lt0+eyeVec.xyz);
	float NdotL0 = dot(lt0, normal);
	float NdotH0 = dot(halfVec0, normal);
	float4 l0 = lit(NdotL0, NdotH0, 8);
	float3 halfVec1 = normalize(lt1+eyeVec.xyz);
	float NdotL1 = dot(lt1, normal);
	float NdotH1 = dot(halfVec1, normal);
	float4 l1 = lit(NdotL1, NdotH1, 8);
	illum[0] = ((l0.y*color0)+(l1.y*color1));
	illum[1] = ((l0.z*color0)+(l1.z*color1));
	return illum;
}

float3 TangentSpaceTransformNoNormalize(
		float4x4 worldITM,
		float3 surfPos,
		float4 lightPos,
		float3 tangent,
		float3 binormal,
		float3 normal)
{
	float4 lightPosLocal = mul(lightPos, worldITM);
	float3 lightVect = lightPosLocal.xyz-surfPos.xyz;
	float3x3 tangentSpaceTM;
	tangentSpaceTM[0] = tangent;
	tangentSpaceTM[1] = binormal;
	tangentSpaceTM[2] = normal;
	return mul(tangentSpaceTM, lightVect);
}

Technique1_Pass1_VS_OUT Technique1_Pass1_VS(
		float3 pos : POSITION,
		float2 uv0 : TEXCOORD0,
		float3 tangent : TANGENT,
		float3 binormal : BINORMAL,
		float3 norm : NORMAL,
		uniform float4x4 projTM,
		uniform float4x4 worldITM,
		uniform float4 eyePos,
		uniform LightParameters lightArray[4])
{
	Technique1_Pass1_VS_OUT OUT;
	OUT.position = mul(float4(pos.xyz, 1), projTM);
	OUT.uv0 = uv0;
	OUT.uv1 = uv0;
	OUT.eyeVect2 = TangentSpaceTransformNoNormalize(worldITM, pos, eyePos, tangent, binormal, norm);
	float4 lightPos1 = lightArray[0].position;
	float4 vect1 = TangentSpaceTransform(worldITM, pos, lightPos1, tangent, binormal, norm);
	OUT.light0Vect = (vect1*0.5)+0.5;
	float4 lightPos2 = lightArray[1].position;
	float4 vect2 = TangentSpaceTransform(worldITM, pos, lightPos2, tangent, binormal, norm);
	OUT.light1Vect = (vect2*0.5)+0.5;
	OUT.eyeVect = TangentSpaceTransform(worldITM, pos, eyePos, tangent, binormal, norm);
	return OUT;
}

Technique1_Pass1_PS_OUT Technique1_Pass1_PS(
		float2 uv1 : TEXCOORD1,
		float3 eyeVect2 : TEXCOORD2,
		float3 eyeVect : TEXCOORD3,
		float4 light0Vect : COLOR0,
		float4 light1Vect : COLOR1,
		uniform sampler2D Texture2Sampler,
		uniform sampler2D TextureSampler,
		uniform sampler2D Texture3Sampler,
		uniform LightParameters lightArray[4])
{
	Technique1_Pass1_PS_OUT OUT;
	float4 height1 = tex2D(TextureSampler, uv1.xy);
	float2 uv2 = Parallax(uv1, eyeVect2, height1, 0.074153296649456);
	float4 a1 = tex2D(Texture2Sampler, uv2.xy);
	float4 color1 = tex2D(Texture3Sampler, uv2.xy);
	float4 normal1 = (color1-0.5)*2;
	float4 color01 = lightArray[0].color;
	float4 color11 = lightArray[1].color;
	float2x3 difSpec1 = PerPixelLighting(normal1, float4(eyeVect.x, eyeVect.y, eyeVect.z, 0), light0Vect, light1Vect, color01, color11);
	float4 b1 = float4(difSpec1[0], 1);
	OUT.color = a1*b1;
	return OUT;
}


// Techniques
technique Technique1
{
	pass Pass1
	{
		VertexShader = compile vs_3_0 Technique1_Pass1_VS(projTM, worldITM, eyePos, lightArray);
		PixelShader = compile ps_3_0 Technique1_Pass1_PS(Texture2Sampler, TextureSampler, Texture3Sampler, lightArray);
		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		AlphaBlendEnable = false;
	}
}

