//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 2/25/2005 2:10:50 PM                 //
//                                                     //
//-----------------------------------------------------//


// Structures
struct Technique1_Pass1_VS_OUT 
{
	float4 position : POSITION;
	float2 uv0 : TEXCOORD0;
	float falloff : TEXCOORD1;
};

struct Technique1_Pass1_PS_OUT 
{
	float4 color : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
float4x4 worldTM : World;
float4x4 worldITTM : WorldIT;
float4 eyePos : WorldEyePosition;
texture Texture
<
	string name = "wetrock.dds";
	string UIName = "Texture";

>;
float4 Color
<
	string UIType = "MaxSwatch";
	string UIName = "Color";

> = {1, 1, 0, 1.0};
float Scalar
<
	string UIType = "MaxSpinner";
	string UIName = "Scalar";

> = 0.7;

// Samplers
sampler2D TextureSampler = sampler_state
{
	Texture = <Texture>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


// Functions
Technique1_Pass1_VS_OUT Technique1_Pass1_VS(
		float3 pos : POSITION,
		float2 uv0 : TEXCOORD0,
		float3 norm : NORMAL,
		uniform float4x4 projTM,
		uniform float4x4 worldTM,
		uniform float4x4 worldITTM,
		uniform float4 eyePos)
{
	Technique1_Pass1_VS_OUT OUT;
	OUT.position = mul(float4(pos.xyz, 1), projTM);
	OUT.uv0 = uv0;
	float4 surfPos1 = mul(float4(pos.xyz, 1), worldTM);
	float3 surfNorm1 = normalize(mul(norm, (float3x3)worldITTM));
	float val1 = max(0, dot(surfNorm1, normalize(eyePos.xyz-surfPos1)));
	float a1 = 1-val1;
	OUT.falloff = a1*a1;
	return OUT;
}

Technique1_Pass1_PS_OUT Technique1_Pass1_PS(
		float2 uv0 : TEXCOORD0,
		float falloff : TEXCOORD1,
		uniform sampler2D TextureSampler,
		uniform float4 Color,
		uniform float Scalar)
{
	Technique1_Pass1_PS_OUT OUT;
	float4 color01 = tex2D(TextureSampler, uv0.xy);
	float4 a1 = color01-0.5;
	float4 a2 = a1*1;
	float4 vect1 = a2+0.5;
	float b1 = vect1.x;
	float4 a3 = Color*b1;
	float4 b2 = a3*2;
	float4 a4 = color01*b2;
	float b3 = falloff*1;
	float4 b4 = a4*b3;
	float4 color11 = min(a4, b4);
	float4 u1 = color01*Scalar;
	OUT.color = lerp(color01, color11, u1);
	return OUT;
}


// Techniques
technique Technique1
{
	pass Pass1
	{
		VertexShader = compile vs_3_0 Technique1_Pass1_VS(projTM, worldTM, worldITTM, eyePos);
		PixelShader = compile ps_3_0 Technique1_Pass1_PS(TextureSampler, Color, Scalar);
		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		AlphaBlendEnable = false;
	}
}

