//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 2/25/2005 2:15:54 PM                 //
//                                                     //
//-----------------------------------------------------//


// Structures
struct Technique1_Pass1_VS_OUT 
{
	float4 position : POSITION;
	float2 uv0 : TEXCOORD0;
	float falloff1 : TEXCOORD1;
	float3 reflectVector : TEXCOORD2;
	float3 refractVector0 : TEXCOORD3;
	float3 refractVector1 : TEXCOORD4;
	float3 refractVector2 : TEXCOORD5;
};

struct Technique1_Pass1_PS_OUT 
{
	float4 color : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
float4x4 worldTM : World;
float4 eyePos : WorldEyePosition;
float4x4 worldITTM : WorldIT;
float Blue_Refr_Index
<
	string UIType = "MaxSpinner";
	string UIName = "Blue Refr Index";

> = 1.3;
float Red_Refr_Index
<
	string UIType = "MaxSpinner";
	string UIName = "Red Refr Index";

> = 1.2;
float Green_Refr_Index
<
	string UIType = "MaxSpinner";
	string UIName = "Green Refr Index";

> = 1.25;
texture Refraction
<
	string name = "C:\\Program Files\\RTzen\\RTshaderGinza\\media\\images\\nvlobby_cube_mipmap.dds";
	string type = "CUBE";
	string UIName = "Refraction";

>;
texture Refraction2
<
	string name = "C:\\Program Files\\RTzen\\RTshaderGinza\\media\\images\\nvlobby_cube_mipmap.dds";
	string type = "CUBE";
	string UIName = "Refraction2";

>;
texture Refraction3
<
	string name = "C:\\Program Files\\RTzen\\RTshaderGinza\\media\\images\\nvlobby_cube_mipmap.dds";
	string type = "CUBE";
	string UIName = "Refraction3";

>;
texture Reflection
<
	string name = "C:\\Program Files\\RTzen\\RTshaderGinza\\media\\images\\nvlobby_cube_mipmap.dds";
	string type = "CUBE";
	string UIName = "Reflection";

>;

// Samplers
samplerCUBE RefractionSampler = sampler_state
{
	Texture = <Refraction>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

samplerCUBE Refraction2Sampler = sampler_state
{
	Texture = <Refraction2>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

samplerCUBE Refraction3Sampler = sampler_state
{
	Texture = <Refraction3>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

samplerCUBE ReflectionSampler = sampler_state
{
	Texture = <Reflection>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


// Functions
float3 RefractEyeVector(
		float4 surfPos,
		float3 surfNorm,
		float4 eyePos,
		float refIndex)
{
	float3 I = normalize(surfPos.xyz-eyePos.xyz);
	float IdotN = dot(I, surfNorm);
	float k = 1-((refIndex*refIndex)*(1-(IdotN*IdotN)));
	return (refIndex*I)-(((refIndex*IdotN)+sqrt(k))*surfNorm);
}

float Falloff(
		float4 surface,
		float4 eye,
		float3 norm,
		float amount)
{
	float3 eyeVect = normalize(eye.xyz-surface.xyz);
	float falloff = 1-dot(eyeVect, norm);
	return pow(falloff, amount);
}

Technique1_Pass1_VS_OUT Technique1_Pass1_VS(
		float3 pos : POSITION,
		float2 uv0 : TEXCOORD0,
		float3 norm : NORMAL,
		uniform float4x4 projTM,
		uniform float4x4 worldTM,
		uniform float4 eyePos,
		uniform float4x4 worldITTM,
		uniform float Blue_Refr_Index,
		uniform float Red_Refr_Index,
		uniform float Green_Refr_Index)
{
	Technique1_Pass1_VS_OUT OUT;
	OUT.position = mul(float4(pos.xyz, 1), projTM);
	OUT.uv0 = uv0;
	float4 surface1 = mul(float4(pos.xyz, 1), worldTM);
	float3 norm1 = normalize(mul(norm, (float3x3)worldITTM));
	OUT.falloff1 = Falloff(surface1, eyePos, norm1, 1);
	OUT.reflectVector = reflect(normalize(surface1-eyePos), norm1).xyz;
	OUT.refractVector0 = RefractEyeVector(surface1, norm1, eyePos, Blue_Refr_Index);
	OUT.refractVector1 = RefractEyeVector(surface1, norm1, eyePos, Red_Refr_Index);
	OUT.refractVector2 = RefractEyeVector(surface1, norm1, eyePos, Green_Refr_Index);
	return OUT;
}

Technique1_Pass1_PS_OUT Technique1_Pass1_PS(
		float3 refractionVector1 : TEXCOORD4,
		float3 refractionVector2 : TEXCOORD5,
		float3 refractionVector0 : TEXCOORD3,
		float3 reflectVector : TEXCOORD2,
		float falloff1 : TEXCOORD1,
		uniform samplerCUBE RefractionSampler,
		uniform samplerCUBE Refraction2Sampler,
		uniform samplerCUBE Refraction3Sampler,
		uniform samplerCUBE ReflectionSampler)
{
	Technique1_Pass1_PS_OUT OUT;
	float4 vect1 = texCUBE(RefractionSampler, refractionVector1.xyz);
	float xValue1 = vect1.x;
	float4 vect2 = texCUBE(Refraction2Sampler, refractionVector2.xyz);
	float yValue1 = vect2.y;
	float4 vect3 = texCUBE(Refraction3Sampler, refractionVector0.xyz);
	float zValue1 = vect3.z;
	float4 a1 = float4(xValue1, yValue1, zValue1, 1);
	float4 a2 = texCUBE(ReflectionSampler, reflectVector.xyz);
	float4 b1 = a2*falloff1;
	OUT.color = a1+b1;
	return OUT;
}


// Techniques
technique Technique1
{
	pass Pass1
	{
		VertexShader = compile vs_3_0 Technique1_Pass1_VS(projTM, worldTM, eyePos, worldITTM, Blue_Refr_Index, Red_Refr_Index, Green_Refr_Index);
		PixelShader = compile ps_3_0 Technique1_Pass1_PS(RefractionSampler, Refraction2Sampler, Refraction3Sampler, ReflectionSampler);
		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		AlphaBlendEnable = false;
	}
}

