//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 2/25/2005 2:14:53 PM                 //
//                                                     //
//-----------------------------------------------------//


// Structures
struct Technique1_Pass1_VS_OUT 
{
	float4 position : POSITION;
	float2 uv0 : TEXCOORD0;
	float2 uv1 : TEXCOORD1;
};

struct Technique1_Pass1_PS_OUT 
{
	float4 color : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
texture Texture
<
	string name = "rtzen.tga";
	string UIName = "Texture";

>;
float time : Time = 0.0;
float Speed
<
	string UIType = "MaxSpinner";
	string UIName = "Speed";

> = 50;

// Samplers
sampler2D TextureSampler = sampler_state
{
	Texture = <Texture>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


// Functions
float2 FilterName(
		float2 uv,
		float t,
		float speed)
{
	float c;
	float s;
	sincos(radians(t*speed), s, c);
	float2 newUV;
	newUV.x = ((uv.x*c)-(uv.y*s));
	newUV.y = ((uv.y*c)+(uv.x*s));
	return newUV;
}

Technique1_Pass1_VS_OUT Technique1_Pass1_VS(
		float3 pos : POSITION,
		float2 uv0 : TEXCOORD0,
		uniform float4x4 projTM)
{
	Technique1_Pass1_VS_OUT OUT;
	OUT.position = mul(float4(pos.xyz, 1), projTM);
	OUT.uv0 = uv0;
	OUT.uv1 = uv0;
	return OUT;
}

Technique1_Pass1_PS_OUT Technique1_Pass1_PS(
		float2 uv1 : TEXCOORD1,
		uniform sampler2D TextureSampler,
		uniform float time,
		uniform float Speed)
{
	Technique1_Pass1_PS_OUT OUT;
	float2 vect1 = FilterName(uv1, time, Speed);
	float a1 = vect1.x;
	float xValue1 = a1*2;
	float a2 = vect1.y;
	float yValue1 = a2*4;
	float2 uv2 = float2(xValue1, yValue1);
	OUT.color = tex2D(TextureSampler, uv2.xy);
	return OUT;
}


// Techniques
technique Technique1
{
	pass Pass1
	{
		VertexShader = compile vs_3_0 Technique1_Pass1_VS(projTM);
		PixelShader = compile ps_3_0 Technique1_Pass1_PS(TextureSampler, time, Speed);
		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		AlphaBlendEnable = false;
	}
}

