//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 2/25/2005 2:13:34 PM                 //
//                                                     //
//-----------------------------------------------------//


// Structures
struct LightParameters 
{
	float4 position;
	float4 color;
};

struct Technique1_Pass1_VS_OUT 
{
	float4 position : POSITION;
	float2 uv0 : TEXCOORD0;
	float2 uv1 : TEXCOORD1;
	float4 diffuseColor : COLOR0;
	float4 specularColor : COLOR1;
};

struct Technique1_Pass1_PS_OUT 
{
	float4 color : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
LightParameters lightArray[4] : WorldLightParameters;
float4x4 worldTM : World;
float4x4 worldITTM : WorldIT;
float4 eyePos : WorldEyePosition;
texture Texture
<
	string name = "rtzen.tga";
	string UIName = "Texture";

>;

// Samplers
sampler2D TextureSampler = sampler_state
{
	Texture = <Texture>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


// Functions
float2x3 LightArray(
		LightParameters lights[4],
		float lightCount,
		float4 surfPos,
		float3 surfNorm,
		float4 eyePos,
		float specPow)
{
	float2x3 illum = float2x3(0, 0, 0, 0, 0, 0);
	float3 eyeVec = normalize(eyePos.xyz-surfPos);
	for (int i = 0;i<lightCount; i = (i+1))
	{
		float3 lightVect = normalize(lights[i].position.xyz-surfPos);
		float3 halfVec = normalize(lightVect+eyeVec);
		float NdotL = dot(lightVect, surfNorm);
		float NdotH = dot(surfNorm, halfVec);
		float4 l = lit(NdotL, NdotH, specPow);
		illum[0] = (illum[0]+(l.y*lights[i].color.xyz));
		illum[1] = (illum[1]+(l.z*lights[i].color.xyz));
	};
	return illum;
}

Technique1_Pass1_VS_OUT Technique1_Pass1_VS(
		float3 pos : POSITION,
		float2 uv0 : TEXCOORD0,
		float3 norm : NORMAL,
		uniform float4x4 projTM,
		uniform LightParameters lightArray[4],
		uniform float4x4 worldTM,
		uniform float4x4 worldITTM,
		uniform float4 eyePos)
{
	Technique1_Pass1_VS_OUT OUT;
	OUT.position = mul(float4(pos.xyz, 1), projTM);
	OUT.uv0 = uv0;
	float a1 = uv0.x;
	float xValue1 = a1*2;
	float a2 = uv0.y;
	float yValue1 = a2*4;
	OUT.uv1 = float2(xValue1, yValue1);
	float4 surfPos1 = mul(float4(pos.xyz, 1), worldTM);
	float3 surfNorm1 = normalize(mul(norm, (float3x3)worldITTM));
	float2x3 difSpec1 = LightArray(lightArray, 4, surfPos1, surfNorm1, eyePos, 8);
	OUT.diffuseColor = float4(difSpec1[0], 1);
	OUT.specularColor = float4(difSpec1[1], 1);
	return OUT;
}

Technique1_Pass1_PS_OUT Technique1_Pass1_PS(
		float2 uv1 : TEXCOORD1,
		float4 diffuse : COLOR0,
		uniform sampler2D TextureSampler)
{
	Technique1_Pass1_PS_OUT OUT;
	float4 a1 = tex2D(TextureSampler, uv1.xy);
	OUT.color = a1*diffuse;
	return OUT;
}


// Techniques
technique Technique1
{
	pass Pass1
	{
		VertexShader = compile vs_3_0 Technique1_Pass1_VS(projTM, lightArray, worldTM, worldITTM, eyePos);
		PixelShader = compile ps_3_0 Technique1_Pass1_PS(TextureSampler);
		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		AlphaBlendEnable = false;
	}
}

